import { StreamDataItem, StreamInterface } from './stream.interface';
export declare class Stream implements StreamInterface {
    readonly type: string;
    protected data: (number | null)[];
    constructor(type: string, data?: (number | null)[]);
    getData(onlyNumeric?: boolean, filterInfinity?: boolean): (number | null)[];
    getDurationOfData(onlyNumeric?: boolean, filterInfinity?: boolean): (number | null)[];
    setData(data: (number | null)[]): this;
    getStreamDataByTime(startDate: Date, onlyNumeric?: boolean, filterInfinity?: boolean): StreamDataItem[];
    getStreamDataByDuration(offset?: number, onlyNumeric?: boolean, filterInfinity?: boolean): StreamDataItem[];
    isUnitDerivedDataType(): boolean;
    toJSON(): StreamJSONInterface;
    private shouldDataBeFiltered;
}
export interface StreamJSONInterface {
    type: string;
    data: (number | null)[];
}
